function Norm = CalculDeNorme(d,h,nx, ny )

% Initialization
x = randn(nx*ny,1 ) ;
p(1) = 1 + 10^(-6) ;
p(2) = 1 ;
n = 2 ;
epsilon = 10^(-10) ;
nmax = 100;
cond = abs( p(2)-p(1) ) / p(2) ;
d12 = sqrt(d);

% Run algorithm
while ( cond >= epsilon && n < nmax)
    
    Gvn = d12.*Convolution2D(x, h,nx, ny ) ;
    xnew = ConvolutionAdj2D(d12.* Gvn, h,nx, ny ) ;
   
    n = n+1 ;
    p(n) = norm(xnew) / norm(x) ;
    cond = abs( p(n)-p(n-1) ) / p(n) ;
    
    x = xnew;
end

% Compute norm
 Norm = p(end-1) ;
 
 
 function Tx = Convolution2D(x,h,nx,ny)

if(size(h,1)*size(h,2)>1)    
        X = reshape(x,nx,ny);                
        Tx = conv2(X,h,'same');
        Tx = Tx(:);                  
else
        Tx = h.*x(:);
end


function Ttz = ConvolutionAdj2D(z,h,nx,ny)

if(size(h,1)*size(h,2)>1)
    Z = reshape(z,ny,nx);
    Ttz = conv2(Z,flipud(fliplr(h)),'same');
    Ttz = Ttz(:);
else
    Ttz = h.*z(:);
end