#ifndef LOGPOISSGAUSS
#define LOGPOISSGAUSS


#include <iostream>
#include <stdio.h>

// TO USE LAMBERT FUNCTION
//#include <iomanip>
//#include <sstream>
//#include <stdlib.h>
#include "LambertW/LambertW.h"


//#include "LamberW2.h"

// MAYBE NOT EVRYTHING IS IMPORTANT

#define SQ(x)	((x) * (x))
#include <math.h>
/*
Parameters:
OUT : ghx - gradient of poisson-gaussian likelihood
IN:   x - estimated image
      y - measurments
      var - variance of the Gaussian noise
      size - size of both images (x,y,ghx)
*/

void gradH (double* ghx,
            double*  x,
            double*  y,
            double var,
            int size);

/*
Parameters:
OUT : crit - poisson-gaussian likelihood
IN:   x - estimated image
      y - measurments
      var - variance of the gaussian noise
      size - size of both images (x,y,ghx)
*/

void critH    (double * crit,
               double * x,
               double * y,
               double var,
               int size);

/*
Parameters:
OUT : ghx - gradient of poisson-gaussian likelihood with benvenutto approximation
IN:   x - estimated image
      y - measurments
      var - variance of the Gaussian noise
      size - size of both images (x,y,ghx)
*/

void gradH_benvenutto      (double* ghx,
                 double*  x,
                 double*  y,
                 double var,
                 int size);


void gradPG     (double* ghx,
                 double*  x,
                 double*  y,
				 double*  exp_table_y,
				 double*  exp_table_n,
                 double var,
                 double alpha,
                 double mean,   
                 int size,
                 int nmax   );

void gradPGp     (double* ghx,
                 double*  x,
                 double*  y,
				 double*  exp_table_y,
				 double*  exp_table_n,
                 double var,
                 double alpha,
                 double mean,   
                 int size,
                 int nmax   );	

void gradPGpp     (double* ghx,
                 double*  x,
                 double*  y,
				 double*  exp_table_y,
				 double*  exp_table_n,
                 double var,
                 double alpha,
                 double mean,   
                 int size,
                 int nmax   );				 
				 
				 
void inittabn(double* exp_table_n, double var, double alpha, int maxn);
void inittaby(double *exp_table_y, double *y, int size, double var, double alpha, double mean);

void init_exp_table_y(double *y);
void delete_exp_table_n();
void delete_exp_table_y();

#endif // LOGPOISSGAUSS
