function yout = dataTruncation(data_fidelity, y, v, m)

switch data_fidelity 
    case 'PoissGauss'
        % no truncation
        yout = y;
    case 'Gauss'
        % no truncation 
        yout = y;
    case 'Poiss'
        % poistivity constraint 
        yout = max(y,0);
    case 'SPoiss'
        % convexity constraint (here we include variance)
        yout = y;
        ind = find(y+v<0);
        yout(ind) = 0;  
    case 'GAST'
        % GAST transform
        cteGAST = 3/8  + v; %Generalized Anscombe transform on y !
        yout = 2*sqrt(max(y + cteGAST,0)) ;
    case 'EXP'
        % convexity constraint
        yout = y;
        ind = find(y + v - 0.5<0);
        yout(ind) = 0.001;
    case 'WL2'
        % no truncation
        yout = y;
end