function gamma = getGammaHyb(data_fidelity, L1,L2, h, y, v, m, nx,ny)


%normh = normest(h, 1e-3);
normh = max(max(abs(fft2(h)).^2));
normL1 = normest(L1, 1e-3);
normL2 = normest(L2, 1e-3);
SQnormVsum = normL1^2 + normL2^2;

switch data_fidelity
    
    case 'PoissGauss'
        
        mu = normh^2 * ( 1 - exp(-1/v) ) * exp ( (2* (max(y) - m) -1 )/v);
        tau = mu + SQnormVsum^0.5; 
        
    case 'Gauss'
        
        mu = normh^2/(2*v) ;
        tau = mu + SQnormVsum^0.5;   
        
    case 'Poiss'
        
        tau =  sqrt(normh^2 + SQnormVsum)^2;
    
    case 'SPoiss' 
        
        tau =  sqrt(normh^2 + SQnormVsum)^2; % we assume here that we compute prox
        
    case 'GAST'
        
        cteGAST = 3/8  + v; %Generalized Anscombe transform on y !
        %yGAST = 2*sqrt(max(y + cteGAST,0)) ;
        Mu = (cteGAST^(-3/2)) * y./2  ; %Lipschitz constant of GAST criterion
        if(h==1)
            mu = max(Mu);
        else
            mu = CalculDeNorme(Mu,h,nx, ny );
        end
        tau = mu + SQnormVsum^0.5;   
        
    case 'EXP'
        coef = (2*(y)-ones(size(y)))/(2*v);
        coef1 = (2*(y)+2*v-ones(size(y)))/(2*v^2);
        Mu = coef1.*exp(coef);
        mu = normh^2 * max(Mu(:));
        tau = mu + SQnormVsum^0.5; 
        
    case 'WL2'
        
        a = 1; b = v;
        mu = normh^2 * max((a.*y + b).^2./b^3);
        tau = mu + SQnormVsum^0.5; 
end


epsilon = min(1e-8,1/(tau+1)); 
gamma=  (1-epsilon)/tau; 
